package org.eclipse.team.examples.pessimistic;

import org.eclipse.core.resources.IFileModificationValidator;
import org.eclipse.core.resources.IResource;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.team.core.RepositoryProvider;


public class PessimisticProvider extends RepositoryProvider {
	public static String ID= PessimisticFilesystemProviderPlugin.FSNATURE_ID;
	private IFileModificationValidator validator; 
	
	public PessimisticProvider() {
		validator = new PessimisticFileModificationValidator();
	}		

	/*
	 * @see RepositoryProvider#getID()
	 */
	public String getID() {
		return ID;
	}

	public IFileModificationValidator getFileModificationValidator() {
		return validator;
	}
	
	public void deconfigure() {
	}
	
	public void configureProject() {
	}
	
	public void checkin(IResource[] resources, IProgressMonitor monitor) {
		for(int i= 0; i < resources.length; i++) {
			IResource resource= resources[i];
			resource.setReadOnly(true);
			touch(resource);
		}
	}
	
	public void uncheckout(IResource[] resources, IProgressMonitor monitor) {
		for(int i= 0; i < resources.length; i++) {
			IResource resource= resources[i];
			resource.setReadOnly(true);
			touch(resource);
		}
	}

	public void checkout(IResource[] resources, IProgressMonitor monitor) {
		for(int i= 0; i < resources.length; i++) {
			IResource resource= resources[i];
			resource.setReadOnly(false);
			touch(resource);
		}
	}	
	
	public boolean isCheckedout(IResource resource) {
		return !resource.isReadOnly();
	}	

	private void touch(IResource resource) { 
		try {
			resource.touch(null);
		} catch(CoreException e) {
		}		
	}	
}

