package org.eclipse.team.examples.pessimistic;

import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.IResource;
import org.eclipse.jface.preference.IPreferenceStore;
import org.eclipse.team.core.RepositoryProvider;
import org.eclipse.team.examples.pessimistic.*;
import org.eclipse.team.examples.pessimistic.ui.ManageFilesDialog;


public class RSCMService {

//	public static final QualifiedName CM_STATUS 			= new QualifiedName("CM", "STATUS");
//	public static final QualifiedName CM_PREVIOUS_NAME		= new QualifiedName("CM", "CMPREVIOUSNAME");
//	public static final QualifiedName CM_MOD_TIME			= new QualifiedName("CM", "CMMODTIME");
//	public static final QualifiedName CM_STATUS_CHANGED 	= new QualifiedName("CM", "CMSTATUSCHANGED");
//	public static final QualifiedName ON_DEMAND_ADD_STATUS 	= new QualifiedName("CM", "ONDEMANDADDSTATUS");
//	public static final QualifiedName VIEW_TYPE 			= new QualifiedName("CM", "VIEWTYPE");
//	public static final QualifiedName VOB_TYPE 				= new QualifiedName("CM", "VOBTYPE");
//	public static final QualifiedName VIEW_TAG 				= new QualifiedName("CM", "VIEWTAG");
//	public static final QualifiedName ACTIVITY_ID			= new QualifiedName("CM", "ACTIVITYID");	
//	public static final String TRUE_AS_STRING 				= new String( "TRUE" );
//	public static final String FALSE_AS_STRING 				= new String( "FALSE" );
//
//	public static final QualifiedName RESOURCE_DETAILS = new QualifiedName("CM", "RESOURCEDETAILS");
	
	private RSCMService() {
	//	cmOperations= new CMOperations( );		
	}
	
	/**
 * Insert the method's description here.
 * Creation date: (2/19/2001 2:57:59 PM)
 * @param models com.rational.startuppkg.cm.UnitStatusCache
 */
//protected void onDemandAdd( UnitStatusCache cache, boolean beQuiet ) {
//
//	String comment = "Adding elements to source control";	
//	int cmd = CommandTypes.CMD_ADD;
//
//	boolean keepCheckedOut = false;
//
//	// return if there are no units
//	if ( cache.isEmpty() )
//	{
//		return;
//	}
//
//	// Remove all already controlled elements from list
//	CMUnitUtil.hasUnitsLike( cache, 
//							 CMUnitUtil.Filters.ControlledF,
//							 CMUnitUtil.FilterType.ALL,
//							 true,	 // discard
//							 true ); // items that matched filter
//
//	if( !cache.isEmpty() )
//	{
//		// Remove all elements from list in build output folders
//		CMUnitUtil.hasUnitsLike( cache, 
//								 CMUnitUtil.Filters.ResourceInBuildOutputFolder,
//								 CMUnitUtil.FilterType.ALL,
//								 true,	 // discard
//								 true ); // items that matched filter
//	}
//	
//	//do not show any elements if they are nature spacific
//	Object[] array = cache.getAllUnits().toArray();
//	IResource resource = null;
//	CMUnit nextU = null;
//	for ( int i=0; i < array.length; i++ )
//	{
//		nextU = (CMUnit) array[i];
//		resource = nextU.getResource();
//		try
//		{
//			if(resource instanceof IProject)
//			{
//				IProject project = (IProject) resource;
//				if(!project.getDescription().hasNature("com.rational.clearcase.ccprovider_nature"))
//				{
//					cache.remove(nextU);
//				}
//			}
//			else if( resource instanceof IFile )
//			{
//				IFile thefile = (IFile) resource;
//				IProject project = thefile.getProject();
//				if(!project.getDescription().hasNature("com.rational.clearcase.ccprovider_nature"))
//				{
//					cache.remove(nextU);
//				}
//			}
//			else if( resource instanceof IFolder )
//			{
//				IFolder thefolder = (IFolder) resource;
//				IProject project = thefolder.getProject();
//				if(!project.getDescription().hasNature("com.rational.clearcase.ccprovider_nature"))
//				{
//					cache.remove(nextU);
//				}
//			}
//			else
//			{
//			}
//		} catch (CoreException ex) {
//			System.out.println("CoreException in onDemandAdd: " + ex.getMessage()); 
//		}
//	}
//	
//	
//	if ( !beQuiet && !cache.isEmpty() )
//	{
//		FrmElementSelection frmElems = new FrmElementSelection( cache,
//																cmd,
//																getCmOperations(),
//																"Add Element(s) to Source Control" );
//		frmElems.showDialog();
//		comment = frmElems.getComment();
//		keepCheckedOut = frmElems.getKeepCheckOut();
//	}
//	
//	if( !cache.isEmpty() )
//	{
//		getCmOperations().add(cache, comment, keepCheckedOut);
//
//		// add a new project description to cache if required
////		getProjectDescription().checkUnits(cache);
//
//		// update status
////		updateStatus( cache );
//	}
//}

	/**
 * Insert the method's description here.
 * Creation date: (2/19/2001 2:57:59 PM)
 * @param models com.rational.startuppkg.cm.UnitStatusCache
 */
protected void onDemandCheckIn( UnitStatusCache cache, boolean beQuiet ) {

	int cmd = IConstants.CMD_CHECKIN;

	// return if there are no units
	if ( cache.isEmpty() )
	{
		return;
	}
	
	// Remove all not checked out elements from selection list
	hasUnitsLike( cache,
					 		 new IFilter() {
						 		 public boolean filter( Object o )
						 		 {
							 		 CMUnit unit = (CMUnit)o;
							 		 return !unit.isCheckedOut(true);
						 		 }
					 		 },
							 FilterType.ALL,
							 true,	 // discard
							 true ); // items that matched filter

	if ( !beQuiet && !cache.isEmpty() )
	{
		ManageFilesDialog frmElems = new ManageFilesDialog( cache,
																cmd,
																//cmOperations,
																"Check In Element(s)" );

		frmElems.showDialog();
	}

	if( !cache.isEmpty() )
	{
		checkin( cache.getAllFiles());
	}
}

public void checkin(IFile[] files) {
	for (int i = 0; i < files.length; i++) {
		IFile f= files[i];
		PessimisticProvider provider= getProvider(f.getProject());
		if (provider != null) {
			provider.checkin(new IResource[] { f }, null);
		}
	}
}

public void checkout(IFile[] files) {
	for (int i = 0; i < files.length; i++) {
		IFile f= files[i];
		PessimisticProvider provider= getProvider(f.getProject());
		if (provider != null) {
			provider.checkout(new IResource[] { f }, null);
		}
	}
}

	/**
 * Insert the method's description here.
 * Creation date: (2/19/2001 2:57:59 PM)
 * @param models com.rational.startuppkg.cm.UnitStatusCache
 * 
 * 
 */
protected void onDemandCheckOut( UnitStatusCache cache, boolean beQuiet, boolean fail ) {

	int cmd = IConstants.CMD_CHECKOUT;
		
	// return if there are no units
	if ( cache.isEmpty() )
	{
		return;
	}

	hasUnitsLike( cache,
							 new IFilter() {
								 public boolean filter( Object o ) {
									 CMUnit unit = (CMUnit)o;
									 return !unit.isControlled(true);
								 }
							 },
							 FilterType.ALL,
							 true,	// discard
							 true ); // items that matched filter

	hasUnitsLike( cache,
							 new IFilter() {
								 public boolean filter( Object o ) {
									 CMUnit unit = (CMUnit)o;
									 return !unit.isCheckedIn();
								 }
							 },
							 FilterType.ALL,
							 true,	// discard
							 true ); // items that matched filter	

	if ( !beQuiet && !cache.isEmpty() )
	{
		ManageFilesDialog frmElems = new ManageFilesDialog( cache,
																cmd,
															//	cmOperations,
																"Check Out Element(s)" );

		frmElems.showDialog();
	}

	if( !cache.isEmpty() && !fail )
	{
		checkout( cache.getAllFiles());

		// update the toolbar
//		updateUI(cache.getAllUnits());
	}
}



	public Object getPreference( String itemId, int type ) {

	IPreferenceStore store = PessimisticFilesystemProviderPlugin.getPlugin().getPreferenceStore();
	
	Object result = null;

	if ( store != null )
	{
		switch ( type )
		{
			case IConstants.RM_BOOLEAN:
			{
				result = new Boolean( store.getBoolean( itemId ) );
				break;
			}
			case IConstants.RM_DOUBLE:
			{
				result = new Double( store.getDouble( itemId ) );
				break;
			}
			case IConstants.RM_FLOAT:
			{
				result = new Float( store.getFloat( itemId ) );
				break;
			}
			case IConstants.RM_INT:
			{
				result = new Integer( store.getInt( itemId ) );
				break;
			}
			case IConstants.RM_LONG:
			{
				result = new Long( store.getLong( itemId ) );
				break;
			}
			case IConstants.RM_STRING:
			{
				result = store.getString( itemId );
				break;
			}
			default:
			{
				break;
			}
		}
	}

	return result;
}


public Vector getUnitsForOnDemandScenario( String itemId, int preferenceType, Vector listOfUnits ) {

	Vector list = new Vector();
//	int cmPreference = -1;
	
	Integer result = (Integer) getPreference( itemId, IConstants.RM_INT );
	
	if ( result == null )
	{

		return list;
	}
	
	CMResourceDataAdapter resourceData = null;
	
	CMUnit unit = null;
	
	for ( int i=0; i < listOfUnits.size(); i++ )
	{
		unit = (CMUnit)listOfUnits.elementAt(i);
		
//		resourceData = unit.getResourceData();
//
//		// case when there is no resource data avaliable
//		if ( resourceData == null )
//		{
//			// use the global preference
			if ( result.intValue() == preferenceType )
			{
				list.add( unit );
			}
//		}
//		else
//		{
//			// check if the resouce data contains this preference
//			cmPreference = 0; // resourceData.getCmPreferences();
//
//			if ( (cmPreference & preferenceType) != 0 )
//			{
//				list.add( unit );
//			}
//			else
//			{
//				// use the global preference
//				if ( result.intValue() == preferenceType )
//				{
//					list.add( unit );
//				}
//			}
//		}
	}
	
	return list;
}

	public void onDemand( Vector units, String itemId, boolean fail ) {
	
		// return if there are no units
		if ( units.isEmpty() )
		{
			return;
		}
	
//		// refresh the status of the units
//		if ( !itemId.equals( ICMInternalConstants.RM_WhenWorkspaceIsClosed ) )
//		{
////			updateUI(units);
//		}
				
		Vector unitsWithPrompt = null;
		Vector unitsWithAutomatic = null;
	
		unitsWithPrompt = getUnitsForOnDemandScenario( itemId,
 													   IConstants.RM_PROMPT,
													   units );
	
		unitsWithAutomatic = getUnitsForOnDemandScenario( itemId,
														  IConstants.RM_AUTOMATIC,
														  units );
	
		// add the resources with a prompt
		UnitStatusCache cache = new UnitStatusCache();
		cache.addUnits( unitsWithPrompt );
		
//		if ( itemId.equals( ICMInternalConstants.RM_WhenNewResourcesAreAdded ) )
//		{
//			onDemandAdd( cache, false );
//		}
		if ( itemId.equals( IConstants.RM_WhenCheckedInFilesAreEdited ) )
		{
			onDemandCheckOut( cache, false, fail );
		}
		if ( itemId.equals( IConstants.RM_WhenCheckedInFilesAreSaved ) )
		{
			onDemandCheckOut( cache, false, fail );
		}
//		if ( itemId.equals( ICMInternalConstants.RM_WhenWorkspaceIsClosed ) )
//		{
//			onDemandCheckIn( cache, false );
//		}
			
		// add the resources automatically
		cache.clear();
		cache.addUnits( unitsWithAutomatic );
//		if ( itemId.equals( ICMInternalConstants.RM_WhenNewResourcesAreAdded ) )
//		{
//			onDemandAdd( cache, true );
//		}

		if ( itemId.equals( IConstants.RM_WhenCheckedInFilesAreEdited ) )
		{
			onDemandCheckOut( cache, true, fail );
		}
		if ( itemId.equals( IConstants.RM_WhenCheckedInFilesAreSaved ) )
		{
			onDemandCheckOut( cache, true, fail );
		}
//		if ( itemId.equals( ICMInternalConstants.RM_WhenWorkspaceIsClosed ) )
//		{
//			onDemandCheckIn( cache, true );
//		}
	}

	public Vector convertToCMUnits(IFile[] objects, boolean doNotApplyFilter) {
		Vector list = new Vector();
		IProject project = null;
	
		for ( int i = 0; i < objects.length ; i++ )
		{
			if ( objects[i] == null )
			{
//				ClearCasePlugin.logTrace( "RSCMService::convertToCMUnits: Object " +
//									 	  "at index " + i + " is null", null );
				continue;
			}
	
			if ( doNotApplyFilter )
			{
				list.addElement( new CMUnit( objects[i] ) );
				continue;
			}
			
			if ( objects[i] instanceof IProject )
			{
				project = (IProject) objects[i];
				
				if ( !project.isOpen() )
				{
					continue;
				}
			}
	
			if ( !objects[i].isLocal(IResource.DEPTH_ZERO) )
			{
				continue;
			}
	
			if ( objects[i].isPhantom() )
			{
				continue;
			}
	
			list.addElement( new CMUnit( objects[i] ) );
		}
	
		return list;
	}


	public static RSCMService getInstance() {
		return new RSCMService();
	}

/**
 * Insert the method's description here.
 * Creation date: (6/7/2001 5:27:26 PM)
 */
public int getCMStatus( CMUnit unit ) {
	
	if (unit.isCheckedOut(false))
		return IConstants.RS_CheckedOut;
	return IConstants.RS_Controlled;
	// ICMConstants.RS_Invalid
	// ICMConstants.RS_NotControlled
	
//	if ( !isClearCaseMode() )
//	{
//		return ICMConstants.RS_Invalid;
//	}
//	
//	Integer result = null;
//	
//	try {
//		result = (Integer) resource.getSessionProperty( RSCMService.CM_STATUS );
//	}
//	catch ( CoreException e )
//	{
//		ClearCasePlugin.logError( e.getMessage(), e );
//	}
//	
//	if ( result != null )
//	{
//		return result.intValue();
//	}
//	else
//	{
//		return ICMConstants.RS_Invalid;
//	}
}

	
public PessimisticProvider getProvider(IProject project) {
	return (PessimisticProvider)RepositoryProvider.getProvider(project, PessimisticProvider.ID);
}

	private Hashtable listOfProjectSettings= new Hashtable();
	
public java.util.Hashtable getListOfProjectSettings() {
	return listOfProjectSettings;
}

	// attribute to hold the current mode (clearcase mode or filesystem mode)
//	private int mode;
	
//public boolean isClearCaseMode() {
//	return (mode == ICMInternalConstants.RM_CLEARCASE_MODE);
//}



	private Vector listOfUpdateUIListeners = new Vector();	
public java.util.Vector getListOfUpdateUIListeners() {
	return listOfUpdateUIListeners;
}	

/**
	 * The number of items that matched the query. This count is reset
	 * each time a new query is run.
	 */
	protected static int cntMatched = 0;

/**
	 * The number of items that did not match the query. This count is
	 * reset each time a new query is run.
	 */
	protected static int cntNotMatched = 0;


	static private boolean hasDone( FilterType scope )
	{
		if( (scope == FilterType.NONE) && (cntMatched == 0) )
			return true;
		
		if( (scope == FilterType.ALL) && (cntNotMatched == 0) )
			return true;
			
		if( (scope == FilterType.ATLEASTONE) && (cntMatched > 0) )
			return true;
		
		return false;
	}

/** 
	 *
	 */
	static private boolean hasTest( Object o, 
							 FilterType scope, 
							 boolean discard,
							 boolean removeMatched, 
							 IFilter  filter,
							 IRemover remover)
	{
		boolean done = false;
		
		if( filter.filter( o ) )
		{
			cntMatched++;
										
			if( scope == FilterType.ATLEASTONE )
				done = true;
						
			if( discard && removeMatched )
			{
				remover.remove( o );					
			}
		}
		else
		{
			cntNotMatched++;
			if( discard && !removeMatched )
				remover.remove( o );
		}
		return done;
	}

/**
	 * Searches units in a cache for filter condition and scope.
	 */
	static public boolean hasUnitsLike( final UnitStatusCache models,
										IFilter filter,
										FilterType scope,
										boolean discard,
										boolean removeMatched )
	{
		boolean done = false;
		cntMatched = cntNotMatched = 0;
		
		for (Enumeration e = models.elements() ; !done && e.hasMoreElements() ;) 
		{
			Enumeration u = 
				((UnitStatusCache.CMModel)e.nextElement()).elements();
			
			while( u.hasMoreElements() && !done )
			{	
				CMUnit unit = (CMUnit)u.nextElement();
				done = hasTest( unit, scope,
								discard, removeMatched, filter,
								new IRemover() {
									public void remove( Object o )
									{
										models.remove( (CMUnit)o );
									}
								} );								
			}
		}
		return hasDone( scope );
	}

	/**
	 * Remover interface, used to allow generic algorithm to run on both
	 * UnitStatusCache and Vector collections. Can be removed if we move
	 * to using Iterators.
	 */
	public interface IRemover
	{
		public void remove( Object o );
	}
	
	/**
	 * Inner class defines scope that used for hasUnitsLike() algorithm. These
	 * allow the user of the operation to qualify the scope of the query.
	 */
	public static final class FilterType
	{
		public static final FilterType ALL		  = new FilterType();
		public static final FilterType NONE		  = new FilterType();
		public static final FilterType ATLEASTONE = new FilterType();
											
		private FilterType() {}
	}
	
	public interface IFilter {
		public boolean filter( Object o );
	}
}
