package org.eclipse.team.examples.pessimistic.ui;

import java.util.HashSet;
import java.util.Set;

import org.eclipse.core.resources.IResource;
import org.eclipse.jface.action.IAction;
import org.eclipse.team.core.TeamException;
import org.eclipse.team.examples.pessimistic.PessimisticProvider;

/**
 * @author jed
 *
 * To change this generated comment edit the template variable "typecomment":
 * Workbench>Preferences>Java>Templates.
 */
public class CheckOutAction extends PessimisticProviderAction {


	/**
	 * @see IActionDelegate#run(IAction)
	 */
	public void run(IAction action) {
		System.out.println("Check out");
		
		IResource[] resources= getSelectedResources();
		if (resources == null || resources.length == 0)
			return;
		Set resourceSet= new HashSet(resources.length);
		for(int i= 0; i < resources.length; i++) {
			IResource resource= resources[i];
			if (isControlled(resource)) {
				if (!isCheckedOut(resource)) {
					resourceSet.add(resource);
				}
			}
		}
		if (!resourceSet.isEmpty()) {
			resources= new IResource[resourceSet.size()];
			resourceSet.toArray(resources);
			checkOut(resources);
		}
	}
	
	private void checkOut(IResource[] resources) {
		PessimisticProvider provider= getProvider(resources[0]);
		if (provider == null)
			return;
			
		provider.checkout(resources, null);
	}
	
	/**
	 * @see PessimisticProviderAction#shouldEnableFor(IResource)
	 */
	protected boolean shouldEnableFor(IResource resource) {
		PessimisticProvider provider= getProvider(resource);
		if (provider == null)
			return false;
		return !provider.isCheckedout(resource);
	}	
}
