package org.eclipse.team.examples.pessimistic.ui;

/*
 * (c) Copyright IBM Corp. 2000, 2001.
 * All Rights Reserved.
 */

import org.eclipse.core.resources.IProject;
import org.eclipse.jface.wizard.Wizard;
import org.eclipse.team.core.Team;
import org.eclipse.team.core.TeamException;
import org.eclipse.team.examples.pessimistic.PessimisticProvider;
import org.eclipse.team.ui.IConfigurationWizard;
import org.eclipse.ui.IWorkbench;

/*
 * The file system configuration wizard called when associating a project
 * the the file system provider.
 */
public class ConfigurationWizard extends Wizard /*extends ExamplesWizard*/ implements IConfigurationWizard {
	private IProject project;
	
	public ConfigurationWizard() {
		super();
	}
	
	public void addPages() {
		// workaround wizard bug
		addPage(new BlankPage());
	}
	
	/*
	 * Using the information entered in the main page set the provider for
	 * the given project.
	 */
	public boolean performFinish() {
		try {
			Team.addNatureToProject(project, PessimisticProvider.ID, null);
		} catch(TeamException e) {
			e.printStackTrace();
			return false;
		}
		return true;
	}
	
	public void init(IWorkbench workbench, IProject project) {
		this.project = project;
	}
}
