package org.eclipse.team.examples.pessimistic.ui;

import java.util.HashSet;
import java.util.Set;

import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.IResource;
import org.eclipse.jface.action.IAction;
import org.eclipse.team.core.Team;
import org.eclipse.team.core.TeamException;
import org.eclipse.team.examples.pessimistic.PessimisticProvider;

/**
 * @author jed
 *
 * To change this generated comment edit the template variable "typecomment":
 * Workbench>Preferences>Java>Templates.
 */
public class DisconnectAction extends PessimisticProviderAction {

	/**
	 * @see IActionDelegate#run(IAction)
	 */
	public void run(IAction action) {
		System.out.println("Disconnect");
		
		IResource[] resources= getSelectedResources();
		if (resources == null || resources.length == 0)
			return;
		Set resourceSet= new HashSet(resources.length);
		for(int i= 0; i < resources.length; i++) {
			IResource resource= resources[i];
			if (resource.getType() == IResource.PROJECT) {
				resourceSet.add(resource.getProject());
			}
		}
		if (!resourceSet.isEmpty()) {
			IProject[] projects= new IProject[resourceSet.size()];
			resourceSet.toArray(projects);
			disconnect(projects);
		}
	}
	
	private void disconnect(IProject[] projects) {
		PessimisticProvider provider= getProvider(projects[0]);
		if (provider == null)
			return;
			
		for(int i= 0; i < projects.length; i++) {
			IProject project= projects[i];
			try {
				Team.removeNatureFromProject(project, PessimisticProvider.ID, null);
			} catch(TeamException e) {
				e.printStackTrace();
			}
		}
	}

	/**
	 * @see PessimisticProviderAction#shouldEnableFor(IResource)
	 */
	protected boolean shouldEnableFor(IResource resource) {
		PessimisticProvider provider= getProvider(resource);
		if (provider == null)
			return false;
		return true;
	}
}
