package org.eclipse.team.examples.pessimistic.ui;

/**
 * Insert the type's description here.
 * Creation date: (1/12/2001 10:50:37 AM)
 * @author: Administrator
 */
import java.util.Enumeration;
import java.util.Vector;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.Widget;
import org.eclipse.team.examples.pessimistic.CMUnit;
import org.eclipse.team.examples.pessimistic.PessimisticFilesystemProviderPlugin;
import org.eclipse.team.examples.pessimistic.UnitStatusCache;


public class ManageFilesDialog extends SelectionAdapter /*implements ModifyListener*/ {
	
	// attribute for the command type
	private int cmd = -1;
	
	// attribute for the cm operations object
//	private CMOperations operations = null;
	
	// attribute for the comment associated with this command
//	private String comment = null;
	
	// attribute for holding the collection of models
	private UnitStatusCache models = null;

	// attribute if the elements are to be kept checked out.
//	private boolean keepCheckedOut = false;

	// attribute for dialog title
	private String title = null;

	// attributes for the dialog controls
	private Shell shell = null;
	private Display display = null;
	private Table items = null;
	private Button ok = null;
	private Button cancel = null;	
	private Button selectAll = null;
//	private Button advanced = null;
//	private Button keepChkedOut = null;
//	private Text textBox = null;
//	private Label commentLabel = null;
	private Label itemsLabel = null;

	// attribute for holding the images
//	private CMImageProvider images = null;
/**
 * Insert the method's description here.
 * Creation date: (1/15/2001 1:28:50 PM)
 * @param models com.rational.startuppkg.cm.UnitStatusCache
 * @param cmd int
 * @param operations com.rational.startuppkg.cm.CMOperations
 * @param dialogTitle java.lang.String
 * @param bCalledFromMenu boolean
 * @param unitFilter com.rational.startuppkg.cm.IFilter
 */
public ManageFilesDialog(UnitStatusCache modelList, int command, String dialogTitle ) {

	// initialize the private attributes
	models = modelList;
	cmd = command;

	title = dialogTitle;

	// get the images from the images provider
//	images = new CMImageProvider( );

	// create the widgets
	createWidgets();

	// set up the listeners
	setupListeners();

	// initialise the dialog with the model elements
	initialize();

	// set up the comment and keep checked out fields
//	setUpComment();
}
///**
// * Insert the method's description here.
// * Creation date: (1/26/2001 2:52:28 PM)
// */
//private Button createCheckBox(Composite group, String label) {
//	Button button = new Button(group, SWT.CHECK | SWT.LEFT);
//	button.setText(label);
//	GridData gridData = new GridData();
//	gridData.horizontalSpan = 5;
//	gridData.horizontalAlignment = GridData.FILL;
//	button.setLayoutData(gridData);
//	return button;
//}
/**
 * Insert the method's description here.
 * Creation date: (2/8/2001 10:52:17 AM)
 */
private Composite createComposite( Composite parent ) {

	// create the inner composite
	Composite innerComp = new Composite(parent, SWT.NONE );
	GridData gridData = new GridData();
	gridData.horizontalSpan = 1;
	gridData.horizontalAlignment = GridData.FILL;
	gridData.verticalAlignment = GridData.FILL;
	innerComp.setLayoutData( gridData );	

	// create and set the layout attributes for the inner composite
	GridLayout layout = new GridLayout();
//	layout.numColumns = 1;
//	layout.makeColumnsEqualWidth = true;
//	layout.verticalSpacing = 20;
//	layout.horizontalSpacing = 10;	
//	layout.marginWidth = 10;
//	layout.marginHeight = 20;	
	innerComp.setLayout( layout );

	return innerComp;
}
/**
 * Insert the method's description here.
 * Creation date: (2/8/2001 10:51:19 AM)
 */
private Label createLabel(Composite group, String message) {
	
	Label label = new Label(group, SWT.NONE);
	label.setText(message);	
	GridData gridData = new GridData();
	gridData.horizontalSpan = 5;
	gridData.horizontalAlignment = GridData.BEGINNING;
	label.setLayoutData(gridData);

	return label;
}
/**
 * Insert the method's description here.
 * Creation date: (2/8/2001 10:52:17 AM)
 */
private Button createPushButton( Composite group, String name, String toolTip ) {

	Button button = new Button(group, SWT.PUSH);
	button.setText(name);
	GridData gridData = new GridData();
	gridData.horizontalAlignment = GridData.FILL;
	gridData.verticalAlignment = GridData.FILL;		
	button.setLayoutData( gridData );
	button.setToolTipText( toolTip );
	button.setEnabled( false );

	return button;
}
/**
 * Insert the method's description here.
 * Creation date: (2/8/2001 10:51:19 AM)
 */
private void createShell() {
	
	if ( Display.getCurrent() == null )
	{
		shell = new Shell( (Shell)null, SWT.BORDER | SWT.TITLE | SWT.APPLICATION_MODAL);
	}
	else
	{
		shell = new Shell( Display.getCurrent().getActiveShell(), SWT.BORDER | SWT.TITLE | SWT.APPLICATION_MODAL);		
	}

	// get the current display
	display = shell.getDisplay();

	// create the layout attributes for the shell
	GridLayout layout = new GridLayout();
	layout.numColumns = 5;
//	layout.verticalSpacing = 10;
//	layout.horizontalSpacing = 10;
	layout.makeColumnsEqualWidth = true;
//	layout.marginWidth = 20;
//	layout.marginHeight = 20;

	// set the layout attributes for the shell
	shell.setLayout( layout);
	shell.setText( title );
	shell.setBounds( 300, 300, 525, 375 );	
}
/**
 * Insert the method's description here.
 * Creation date: (2/8/2001 10:51:19 AM)
 */
private Table createTable(Composite group) {

	// create the table
	Table table = new Table( group, SWT.CHECK|SWT.BORDER|SWT.MULTI|SWT.H_SCROLL|SWT.V_SCROLL);
	GridData gridData = new GridData();
	gridData.horizontalSpan = 4;
	gridData.heightHint = 150;
	gridData.horizontalAlignment = GridData.FILL;
	table.setLayoutData( gridData );

	// create the columns
	int[] columnWidths = {150, 150, 75};	
	TableColumn tableColumn1 = new TableColumn(table, SWT.NULL);
	tableColumn1.setWidth(columnWidths[0]);
	tableColumn1.setText("Logical Root");
	TableColumn tableColumn2 = new TableColumn(table, SWT.NULL);
	tableColumn2.setWidth(columnWidths[1]);
	tableColumn2.setText("Storage Path");
	TableColumn tableColumn3 = new TableColumn(table, SWT.NULL);
	tableColumn3.setWidth(columnWidths[2]);
	tableColumn3.setText("CM Status");

	return table;
}
/**
 * Insert the method's description here.
 * Creation date: (2/8/2001 10:52:17 AM)
 */
private Text createTextBox( Composite group ) {
	
	Text textBox = new Text( group, SWT.BORDER | SWT.V_SCROLL );
	GridData gridData = new GridData();
	gridData.horizontalSpan = 5;
	gridData.horizontalAlignment = GridData.FILL;
	gridData.grabExcessHorizontalSpace = true;
	textBox.setLayoutData( gridData );

	return textBox;
}
/**
 * Insert the method's description here.
 * Creation date: (2/1/2001 5:33:37 PM)
 */
private void createWidgets() {

	// create the shell
	createShell();

	// create the label for the table
	itemsLabel = createLabel( shell, "Project Resources:" );

	// create the table and its columns
	items = createTable( shell );

	// create an inner composite for all the buttons
	Composite innerComp = createComposite( shell );

	// create the ok button
	ok = createPushButton( innerComp, "&OK", "Execute the command" );
	shell.setDefaultButton( ok );
	// create the cancel button
	cancel = createPushButton( innerComp, "&Cancel", "Cancel the command" );
	// create the select all button
	selectAll = createPushButton( innerComp, "&Select All", "Select all resources" );
	// create the cancel button
//	advanced = createPushButton( innerComp, "&Advanced", "ClearCase advanced options" );
	// create the keep checked out button
//	keepChkedOut = createCheckBox( shell, "Keep checked out" );
	// create the comment label
//	commentLabel = createLabel( shell, "Comment:" );
	// create the text box
//	textBox = createTextBox( shell );
}
///**
// * Insert the method's description here.
// * Creation date: (1/15/2001 1:31:54 PM)
// * @return java.lang.String
// */
//public java.lang.String getComment() {
//	return comment;
//}
///**
// * Insert the method's description here.
// * Creation date: (1/31/2001 1:08:28 PM)
// * @return boolean
// */
//public boolean getKeepCheckOut() {
//	return keepCheckedOut;
//}
/**
 * Insert the method's description here.
 * Creation date: (2/1/2001 5:42:09 PM)
 */
private void initialize() {

	TableItem item = null;
	CMUnit unit = null;
	String iconPath = null;
	String logicalName = null;
	String[] strList = new String[3];
	Image icoImage = null;
	
	// clear the table items
	items.removeAll();

	// get all the models
	Enumeration e = models.elements();

	// iterate thru all the models	
	while ( e.hasMoreElements() )
	{
		UnitStatusCache.CMModel model = (UnitStatusCache.CMModel) e.nextElement();

		for( int i = 0; i < model.getAllUnits().size(); i++ )
		{
			try {
				unit = (CMUnit) model.getAllUnits().elementAt(i);
				
				item = new TableItem( items, SWT.NULL );
				item.setData( unit );

				// get the default logical name
				logicalName = unit.getResource().getName();

				// get the default icon
	//			icoImage = images.getImage( unit.getResource() );

				// set the text attributes
				strList[0] = logicalName;
				strList[1] = unit.getFullyQualifiedName();
				strList[2] = unit.getCMStatusAsString();

//				// get the logical name icon
//				if ( unit.getResourceData() != null )
//				{
//					// get the logical name
//					logicalName = unit.getResourceData().getLogicalRoot();
//					if ( (logicalName != null) && (logicalName.compareTo("") != 0) )
//					{
//						strList[0] = logicalName;
//					}
//				
//					// get the icon
//					/*iconPath = unit.getResourceData().getIconPath();
//					if ( iconPath != null && iconPath.compareTo("") != 0 )
//					{
//						icoImage = new Image( Display.getCurrent(), iconPath );
//					}
//					else
//					{
//						int handleToIcon = unit.getResourceData().getIconHandle();
//						if ( handleToIcon != -1 )
//						{
//							icoImage = Image.win32_new(Display.getCurrent(), SWT.ICON, handleToIcon);
//						}
//					}*/
//				}

				// set the text
				item.setText( strList );
				// set it checked by default
				item.setChecked(true);
				// set the image
				item.setImage( icoImage );
			}
			catch ( Throwable excep )
			{
				PessimisticFilesystemProviderPlugin.logError( "FrmElementSelection::initialize: Initialization failed", excep );
			}
		}
	}

	// set the state of the cancel button
	cancel.setEnabled( true );

	// set the state of the select all button
	if ( items.getItemCount() > 0 )
	{
		selectAll.setEnabled( true );	
	}

	// set the state of the ok button
	updateOkButton();
	
	// set the items header to visible	
	items.setHeaderVisible( true );
}
///**
// * modifyText method comment.
// */
//public void modifyText(org.eclipse.swt.events.ModifyEvent e) {
//
//	Widget source = e.widget;
//	
////	if ( source == textBox )
////	{
////		comment = textBox.getText();
////	}
//}
///**
// * Insert the method's description here.
// * Creation date: (2/1/2001 4:06:18 PM)
// */
//private void setUpComment() {
//
//	boolean comment = false;
////	ProviderCapabilities capabilities =
////		operations.getAddin().getModelSettings().getImplementor().getCapabilities();
//
//	switch( cmd )
//	{
//		case IConstants.CMD_ADD:
//		{
////			comment = capabilities.commentAdd;
////			keepChkedOut.setSelection(true);
////			keepCheckedOut = keepChkedOut.getSelection();
//			break;
//		}
//		case IConstants.CMD_CHECKIN:
//		{
////			comment = capabilities.commentCheckin;
//			break;
//		}
//		case IConstants.CMD_CHECKOUT:
//		{
////			comment = capabilities.commentCheckout;
////			keepChkedOut.setEnabled( false );
//			break;
//		}
//		default:
//		{
////			keepChkedOut.setEnabled( false );
//		}
//	}
//
//	if( !comment )
//	{
////		commentLabel.setEnabled( false );
////		textBox.setEnabled( false );
//	}
//}
/**
 * Insert the method's description here.
 * Creation date: (2/1/2001 10:34:30 AM)
 */
private void setupListeners() {

	ok.addSelectionListener( this );
	cancel.addSelectionListener( this );
	selectAll.addSelectionListener( this );
//	keepChkedOut.addSelectionListener( this );
//	textBox.addModifyListener( this );
//	advanced.addSelectionListener( this );
	items.addSelectionListener( this );
}
/**
 * Insert the method's description here.
 * Creation date: (1/15/2001 1:29:23 PM)
 * @return boolean
 */
public void showDialog() {

	// open the shell
	shell.open();
	
	// run the event loop
	while ( !shell.isDisposed() )
	{
		if ( !display.readAndDispatch() )
		{
			display.sleep();
		}
	}

//	// dispose of the images
//	images.dispose();
//
//	// set the images attribute to null
//	images = null;
}
/**
 * Insert the method's description here.
 * Creation date: (6/13/2001 12:42:18 PM)
 */
private void updateOkButton() {
	int count = 0;
	TableItem[] array = items.getItems();
	for ( int i=0; i < array.length; i++ )
	{
		if ( array[i].getChecked() )
		{
			count++;
		}
	}

	if ( count > 0 )
	{
		ok.setEnabled( true );
		shell.setDefaultButton( ok );
	}
	else
	{
		ok.setEnabled( false );
		shell.setDefaultButton( cancel );
	}
}
/**
 * Insert the method's description here.
 * Creation date: (2/1/2001 1:32:14 PM)
 */
public void widgetSelected(SelectionEvent e) {
	
	Widget source = e.widget;
		
	if ( source == ok )
	{
		// set up default comment
//		if ( commentLabel.getEnabled() )
//		{
//			if ( textBox.getText().compareTo("") == 0 )
//			{
//				comment = title;
//			}
//		}
		
		// populate the list of selected units	
		Vector listOfSelectedUnits = new Vector();
		models.clear();
		TableItem[] array = items.getItems();
		for ( int i=0; i < array.length; i++ )
		{
			if ( array[i].getChecked() )
			{
				listOfSelectedUnits.addElement( (CMUnit) array[i].getData() );
			}
		}		

		// add the units to the cache
		models.addUnits( listOfSelectedUnits );

		// dispose of the shell
		shell.dispose();
	}
	else if ( source == cancel )
	{
		models.clear();
		shell.dispose();
	}
	else if ( source == selectAll )
	{
		TableItem[] array = items.getItems();
		for ( int i=0; i < array.length; i++ )
		{
			array[i].setChecked( true );
		}

		ok.setEnabled( true );
		ok.setFocus();
	}
//	else if ( source == keepChkedOut )
//	{
//		keepCheckedOut = keepChkedOut.getSelection();
//	}
//	else if ( source == advanced )
//	{
//		//Invoke provider specific policy options.
////		operations.getCommandOptions( cmd, true, operations.getAddin().getModelSettings() );
//	}
	else if ( source == items )
	{
		updateOkButton();
	}
	else
	{
		return;
	}
}
}
